/*
 * Rotating Logo Applet
 * poly3d.java -- 3D Polygon
 * (C) 1998 Filip Pizlo
 */

import java.awt.*;
import java.util.*;

public class poly3d extends Polygon {
 public Vector x,y,z;
 public int d,w2,h2;
 public poly3d(int d,int w2,int h2) {
  super();
  x=new Vector();
  y=new Vector();
  z=new Vector();
  this.d=d;
  this.w2=w2;
  this.h2=h2;
 }
 public void addPoint(int _x,int _y) {
  x.addElement(new Double((double)_x));
  y.addElement(new Double((double)_y));
  z.addElement(new Double((double)0));
  refresh();
 }
 public void refresh() {
  npoints=Math.min(x.size(),Math.min(y.size(),z.size()));
  xpoints=new int[npoints];
  ypoints=new int[npoints];
  for (int i=0;i<npoints;i++) {
   int denom=((Double)z.elementAt(i)).intValue()+d;
   xpoints[i]=(((Double)x.elementAt(i)).intValue()*d)/denom+w2;
   ypoints[i]=h2-(((Double)y.elementAt(i)).intValue()*d)/denom;
  }
 }
}



